/*
 *  core.h
 *  Apto
 *
 *  Created by David on 2/14/11.
 *  Copyright 2011 David Michael Bryson. All rights reserved.
 *  http://programerror.com/software/apto
 *
 *  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 *  following conditions are met:
 *  
 *  1.  Redistributions of source code must retain the above copyright notice, this list of conditions and the
 *      following disclaimer.
 *  2.  Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the
 *      following disclaimer in the documentation and/or other materials provided with the distribution.
 *  3.  Neither the name of David Michael Bryson, nor the names of contributors may be used to endorse or promote
 *      products derived from this software without specific prior written permission.
 *  
 *  THIS SOFTWARE IS PROVIDED BY DAVID MICHAEL BRYSON AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 *  DISCLAIMED. IN NO EVENT SHALL DAVID MICHAEL BRYSON OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
 *  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 *  USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  Authors: David M. Bryson <david@programerror.com>
 *
 */

#ifndef AptoCore_h
#define AptoCore_h

#include "apto/core/Algorithms.h"
#include "apto/core/Array.h"
#include "apto/core/ArrayUtils.h"
#include "apto/core/Atomic.h"
#include "apto/core/ConditionVariable.h"
#include "apto/core/Definitions.h"
#include "apto/core/FileSystem.h"
#include "apto/core/Functor.h"
#include "apto/core/List.h"
#include "apto/core/Map.h"
#include "apto/core/Mutex.h"
#include "apto/core/Matrix.h"
#include "apto/core/Pair.h"
#include "apto/core/PriorityScheduler.h"
#include "apto/core/Random.h"
#include "apto/core/RWLock.h"
#include "apto/core/RefCount.h"
#include "apto/core/RefTransport.h"
#include "apto/core/Set.h"
#include "apto/core/SmartPtr.h"
#include "apto/core/StaticCheck.h"
#include "apto/core/String.h"
#include "apto/core/StringBuffer.h"
#include "apto/core/StringUtils.h"
#include "apto/core/Thread.h"
#include "apto/core/ThreadSpecific.h"
#include "apto/core/TypeList.h"
#include "apto/core/TypeTraits.h"
#include "apto/core/TypeUtil.h"

#endif
