We welcome all those interested to contribute to the development and improvement of the Avida project. This developer’s guide will describe how to get started, the guidelines for contributions, and where to find ideas for what is needed.

## Project Structure
Avida consists of several modules/sub-projects.

* [Avida-Core Library](Development-|-avida-core)
* [Avida-Viewer Library](Development-|-avida-viewer)
* [Avida2 Frontend](Development-|-avida2)
* [The OS X/iOS Viewers](Development-|-viewer-macos)
* [The Windows Viewer](Development-|-viewer-windows)

### [Getting Started](Development-|-Getting-Started)
### [Coding Style Guide](Development-|-Coding-Style-Guide)


## Mini Tutorials
* [A Conceptual Introduction to C++](Development-|-Tutorial-|-C-Plus-Plus-Intro)
* [Guide to the Death/Birth Cycle](Development-|-Tutorial-|-Birth-Death-Cycle)
* [Guide to an Avida Organism Life Cycle](Development-|-Tutorial-|-Life-Cycle)
* [The Building Blocks of the Virtual CPU](Development-|-Tutorial-|-Genome)
* [The Environment Source Code](Development-|-Tutorial-|-Environment)
* [Instruction Implemention Checklist](Development-|-Tutorial-|-Instruction-Checklist)
* [Environment Task Implementation Checklist](Development-|-Tutorial-|-Task-Checklist)
