Avida is a free, open source software platform for conducting and analyzing experiments with self-replicating and evolving computer programs. It provides detailed control over experimental settings and protocols, a large array of measurement tools, and sophisticated methods to analyze and post-process experimental data.

The following articles provide a good introduction to Avida:
* [Testing Darwin](https://carlzimmer.com/testing-darwin-511/) by Carl Zimmer (Cover story of Feb 2005 Discover Magazine).
* [Twice as Natural](http://myxo.css.msu.edu/lenski/pdf/2001,%20Nature,%20Lenski,%20twice%20as%20natural.pdf) by Richard Lenski (2001)
* [Meet the Scientist](http://www.microbeworld.org/index.php?option=com_content&view=article&id=784:mts59-charles-ofria-&catid=37:meet-the-scientist&Itemid=1550) podcast interview of Charles Ofria by Carl Zimmer (2010)

More detailed materials:
* [About Digital Evolution](wiki/About)
* [Avida: A Software Platform for Research in Computational Evolutionary Biology](http://www.cse.msu.edu/~ofria/pubs/2009AvidaIntro.pdf) by C. Ofria, D.M. Bryson, and C. Wilke (2009).
* The contents of this Wiki

If you would like to contribute to this documentation, please create an account via the log-in link at the top-right of the page.

**[New User Information](wiki/New-User-Information)**

## General Information
* [Beginner Documentation](wiki/Beginner-Documentation)
* [Overview](wiki/Overview)
* [A Guided Tour of the Ancestor and its Hardware](wiki/Default-Ancestor-Guided-Tour)
* [Text Viewer](wiki/Text-Viewer)
* [Configuration and Command Reference](wiki/Configuration-and-Command-Reference)
* [Experiment and Analysis Guides](wiki/Experiment-and-Analysis-Guides)


## Developer Resources
* [Developers Guide](wiki/Developers-Guide)
* [Getting Started](wiki/Development-|-Getting-Started)
* [Avida 3 API](wiki/Avida-3-API)